%define	name	naatd
%define	version	2.21b
%define	release	3mdk

%define nuser	httpd-naat
%define ngroup	admin
%define webdir	/var/www-naat
%define port	8443

Summary: 	HTTP server daemon to provide Administrative WWW services
Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	BSD
Group:		System/Servers
URL:		http://www.acme.com/software/thttpd
Source0:	thttpd-%{version}.tar.bz2
Source1:	naatd.init.bz2
Source2:	naatd.conf.bz2
Source3:	throttle.conf.bz2
Source4:	naatd.logrotate.bz2
Source5:	index.html.bz2
Source6:	squidGuard.cgi
Source7:	nulbanner.png
Patch0:		thttpd-2.21b-php.diff.bz2
Patch1:		thttpd-2.21b-debian.diff.bz2
PreReq:		rpm-helper
BuildRequires:	php-devel
Requires:	php-gd
PreReq:		sudo
PreReq:		perl
Requires:	SnortSnarf
Requires:	dhcpstatus
Provides:	httpd-naat
BuildRoot:	%{_tmppath}/%{name}-buildroot

%description
NAATD is based on thttpd server + php support and is meant to be used for
the Network Appliance Administration Tool on MandrakeLinux Server.

%prep

%setup -q -n thttpd-%{version}
%patch0 -p1
%patch1 -p1

bzcat %{SOURCE1} > naatd.init
bzcat %{SOURCE2} > naatd.conf
bzcat %{SOURCE3} > throttle.conf
bzcat %{SOURCE4} > naatd.logrotate
bzcat %{SOURCE5} > naatd-index.html

cp /usr/src/php-devel/sapi/thttpd/thttpd.c php_thttpd.c
cp /usr/src/php-devel/sapi/thttpd/php_thttpd.h .
cp /usr/src/php-devel/sapi/thttpd/CREDITS CREDITS.php-sapi
cp /usr/src/php-devel/sapi/thttpd/README README.php-sapi
cp /usr/src/php-devel/internal_functions.c .
ln -s /usr/src/php-devel/ext .

%build

%configure

%make \
    prefix="%{_prefix}" \
    BINDIR="%{_sbindir}" \
    MANDIR="%{_mandir}" \
    WEBDIR="%{webdir}/html" \
    DEFAULT_USER="%{nuser}" \
    WEBGROUP="%{ngroup}" \
    DEFAULT_PORT="%{port}" \
    CGIBINDIR="%{webdir}/html/cgi-bin" \

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

install -d %{buildroot}%{_initrddir}
install -d %{buildroot}%{_sysconfdir}/logrotate.d
install -d %{buildroot}%{webdir}/html/cgi-bin
install -d %{buildroot}/var/log/naatd
install -d %{buildroot}/var/run/naatd
install -d %{buildroot}%{_sbindir}
install -d %{buildroot}%{_mandir}/man{1,8}

install -m0755 thttpd %{buildroot}%{_sbindir}/naatd
install -m0755 extras/htpasswd %{buildroot}%{_sbindir}/naatd-htpasswd
install -m0755 extras/makeweb %{buildroot}%{_sbindir}/naatd-makeweb
install -m0755 extras/syslogtocern %{buildroot}%{_sbindir}/naatd-syslogtocern
install -m0644 extras/htpasswd.1 %{buildroot}%{_mandir}/man1/naatd-htpasswd.1
install -m0644 extras/makeweb.1 %{buildroot}%{_mandir}/man1/naatd-makeweb.1
install -m0644 extras/syslogtocern.8 %{buildroot}%{_mandir}/man8/naatd-syslogtocern.8
install -m0644 thttpd.8 %{buildroot}%{_mandir}/man8/naatd.8

install -m0755 cgi-bin/printenv %{buildroot}%{webdir}/html/cgi-bin/printenv.cgi
install -m0755 cgi-src/phf %{buildroot}%{webdir}/html/cgi-bin/
install -m0755 cgi-src/redirect %{buildroot}%{webdir}/html/cgi-bin/
install -m0755 cgi-src/ssi %{buildroot}%{webdir}/html/cgi-bin/
install -m0644 cgi-src/redirect.8 %{buildroot}%{_mandir}/man8/naatd-redirect.8
install -m0644 cgi-src/ssi.8 %{buildroot}%{_mandir}/man8/naatd-ssi.8

install -m0755 naatd.init  %{buildroot}%{_initrddir}/naatd
install -m0755 naatd.logrotate  %{buildroot}%{_sysconfdir}/logrotate.d/naatd
install -m0644 naatd.conf %{buildroot}%{_sysconfdir}/naatd.conf
install -m0644 throttle.conf %{buildroot}%{_sysconfdir}/throttle.conf
install -m0644 naatd-index.html %{buildroot}%{webdir}/html/index.html

install -m0755 %{SOURCE6} %{buildroot}%{webdir}/html/cgi-bin/
install -m0644 %{SOURCE7} %{buildroot}%{webdir}/html/

%pre 
#%_pre_useradd naatd /var/www-naat /bin/sh
# Add admin group exist if doesn't exit

#  warly
# 
# FIXME: if the group admin exists before that install create it
# grpconv failed and the install reboot
# 

grep -q '^%{ngroup}:' /etc/passwd || \
  /usr/sbin/useradd -c 'Administrator' \
	-d /home/%{ngroup} -G adm -s /bin/bash %{ngroup}


grep -q '^%{nuser}:' /etc/passwd  || \
	/usr/sbin/useradd -c "Httpd Naat Admin" -s /bin/bash -M \
	 -d /var/www-naat -G %{ngroup},apache %{nuser}

%post
# make SnortSnarf work
#ln -s /var/www/cgi-bin/*.pl %{webdir}/html/cgi-bin/
cp -a /var/www/cgi-bin/add_annotation.pl %{webdir}/html/cgi-bin/
cp -a /var/www/cgi-bin/inclist.pl %{webdir}/html/cgi-bin/
cp -a /var/www/cgi-bin/lsetlist.pl %{webdir}/html/cgi-bin/
cp -a /var/www/cgi-bin/sel_to_add.pl %{webdir}/html/cgi-bin/
cp -a /var/www/cgi-bin/text4sel.pl %{webdir}/html/cgi-bin/
cp -a /var/www/cgi-bin/view_annotations.pl %{webdir}/html/cgi-bin/
cp -a /var/www/cgi-bin/view_lset.pl %{webdir}/html/cgi-bin/

# make dhcpstatus work
cp -a /var/www/cgi-bin/dhcpstatus*cgi %{webdir}/html/cgi-bin/

%_post_service naatd

%preun
%_preun_service naatd

%postun

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc README TODO CREDITS.php-sapi README.php-sapi
%config(noreplace) %attr(0644,root,root)  %{_sysconfdir}/naatd.conf
%config(noreplace) %attr(0644,root,root)  %{_sysconfdir}/throttle.conf
%config(noreplace) %attr(0755,root,root)  %{_initrddir}/naatd
%config(noreplace) %attr(0644,root,root)  %{_sysconfdir}/logrotate.d/naatd
%attr(2755,%{nuser},%{ngroup}) %{_sbindir}/naatd-makeweb
%attr(0755,root,root) %{_sbindir}/naatd-htpasswd
%attr(0755,root,root) %{_sbindir}/naatd-syslogtocern
%attr(0755,root,root) %{_sbindir}/naatd
%attr(0755,%{nuser},%{ngroup}) %dir %{webdir}/html
%attr(0755,%{nuser},%{ngroup}) %dir %{webdir}/html/cgi-bin
%attr(0755,%{nuser},%{ngroup}) %dir /var/log/naatd
%attr(0755,%{nuser},%{ngroup}) %dir /var/run/naatd
%config(noreplace) %attr(0644,root,root) %{webdir}/html/index.html
%attr(0755,root,root) %{webdir}/html/cgi-bin/printenv.cgi
%attr(0755,root,root) %{webdir}/html/cgi-bin/phf
%attr(0755,root,root) %{webdir}/html/cgi-bin/redirect
%attr(0755,root,root) %{webdir}/html/cgi-bin/ssi
%attr(0755,root,root) %{webdir}/html/cgi-bin/squidGuard.cgi
%attr(0644,root,root) %{webdir}/html/nulbanner.png
%attr(0644,root,root) %{_mandir}/man*/*

%changelog
* Sun Jun 20 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 2.21b-3mdk
- heh!, the default config was faulty

* Sat Jun 19 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 2.21b-2mdk
- added a slightly adjusted security patch from debian

* Wed Jun 16 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 2.21b-1mdk
- initial cooker contrib (based on the thttpd package)
